#define F_CPU 16000000
#include<avr/io.h>
#include<util/delay.h>
#include<stdlib.h>

#define RED1 PC0
#define YELLOW1 PC2
#define GREEN1 PC4
#define RED2 PB0
#define GREEN2 PB2
#define BLUE2 PB4
#define ON 1
#define OFF 0
#define C 1
#define B 0
#define SWITCH1_PRESSED() ((PINC & (1<<PC1)) == 0 )
#define SWITCH2_PRESSED() ((PINC & (1<<PC3)) == 0 )
#define SWITCH3_PRESSED() ((PINC & (1<<PC5)) == 0 )

void init_peri() {
    DDRC &= ~((1<<PC1)|(1<<PC3)|(1<<PC5));
    DDRC |= (1<<PC0)|(1<<PC2)|(1<<PC4);
    DDRB |= (1<<PB0)|(1<<PB2)|(1<<PB4);
    PORTC |= ((1<<PC1)|(1<<PC3)|(1<<PC5));
}

void set_led_value(uint8_t pin,uint8_t state,uint8_t port){
    PORTB &= ~((1<<PC0)|(1<<PC2)|(1<<PC4));
    PORTC &= ~((1<<PC0)|(1<<PC2)|(1<<PC4));
    if(state){
         if(port){
                PORTC |= (1<<pin);
         }
         else{
                PORTB |= (1<<pin);
         }
}
int main(){
    init_peri();
    int stage=1;
    int memorylight[101];
    int check=0;
    while(1){
        while(!SWITCH1_PRESSED());
        _delay_ms(20);
        for(int i=0;i<stage+2;i++){
            memorylight[i]= rand()%3 +1;
            if(stage<20){
	_delay_ms(500);
            }
            else if(stage >= 20 && stage < 50){
	_delay_ms(300);
            }
            else{
                    _delay_ms(200);
            }
            if(memorylight[i]==1){
                set_led_value(RED1,ON,C);
            }
            else if(memorylight[i]==2){
                set_led_value(YELLOW1,ON,C);
            }
            else{
                set_led_value(GREEN1,ON,C);
            }
            if(stage<20){
	_delay_ms(500);
            }
            else if(stage >= 20 && stage < 50){
	_delay_ms(300);
            }
            else{
                    _delay_ms(200);
            }
            set_led_value(RED1,OFF,C);
        }

        for(int i=0;i<stage+2;i++){
            check=0;
            if(memorylight[i]==1){
                while(!SWITCH1_PRESSED()){
                    check=1;
                    if(SWITCH2_PRESSED() || SWITCH3_PRESSED()){
                        check=0;
                        set_led_value(RED2,ON,B);
                        _delay_ms(300);
                        set_led_value(RED2,OFF,B);
                        _delay_ms(300);
                        break;
                    }
                }
            }
            else if(memorylight[i]==2){
                while(!SWITCH2_PRESSED()){
                    check=1;
                    if(SWITCH1_PRESSED() || SWITCH3_PRESSED()){
                        check=0;
                        set_led_value(RED2,ON,B);
                        _delay_ms(300);
                        set_led_value(RED2,OFF,B);
                        _delay_ms(300);
                        break;
                    }
                }
            }
            else{
                while(!SWITCH3_PRESSED()){
                    check=1;
                    if(SWITCH1_PRESSED() || SWITCH2_PRESSED()){
                        check=0;
                        set_led_value(RED2,ON,B);
                        _delay_ms(500);
                        set_led_value(RED2,OFF,B);
                        break;
                    }
                }
            }
            if(!check){
                break;
            }
            else{
                set_led_value(GREEN2,ON,B);
                _delay_ms(300);
                set_led_value(GREEN2,OFF,B);
                _delay_ms(300);
            }

        }

        if(!check || stage+1==100){
            stage=1;
        }
        else{
            stage++;
            set_led_value(BLUE2,ON,B);
            _delay_ms(300);
            set_led_value(BLUE2,OFF,B);
            _delay_ms(300);
            set_led_value(BLUE2,ON,B);
            _delay_ms(300);
            set_led_value(BLUE2,OFF,B);
            _delay_ms(300);
            set_led_value(BLUE2,ON,B);
            _delay_ms(300);
            set_led_value(BLUE2,OFF,B);
            _delay_ms(300);
        }
    }
}
